/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEF_TEXT_BUTTON
#define DEF_TEXT_BUTTON

#include <string>
#include "Button.hpp"

//Class representing a text Button
class TextButton : public Button
{
    public:
        TextButton();
        TextButton(const std::string &text, float width, float height, const sf::Color &borderColor);
        
        void setText(const std::string &text);
        const std::string &getText() const;
        
        void setTextFont(const sf::Font &textFont);
        const sf::Font &getTextFont() const;
        
        void setTextSize(unsigned int textSize);
        unsigned int getTextSize() const;
        
        void setTextColor(const sf::Color &textColor);
        const sf::Color &getTextColor() const;
        
        void setTextStyle(unsigned long textStyle);
        unsigned long getTextStyle() const;
    
    private:
        virtual void Render(sf::RenderTarget& target, sf::Renderer& renderer) const;
        void centerText();
        
        sf::Text m_textField;
        std::string m_text;
};

#endif